diff -ru orig/hheretic-0.2.0-src/include/doomdata.h a1200/hheretic-0.2.0-src/include/doomdata.h
--- orig/hheretic-0.2.0-src/include/doomdata.h	2009-05-22 18:22:01.000000000 -0400
+++ a1200/hheretic-0.2.0-src/include/doomdata.h	2009-08-19 16:40:28.000000000 -0400
@@ -48,7 +48,7 @@
 	short		flags;
 	short		special, tag;
 	short		sidenum[2];	/* sidenum[1] will be -1 if one sided */
-} maplinedef_t;
+} __attribute__((packed)) maplinedef_t;
 COMPILE_TIME_ASSERT(maplinedef_t, sizeof(maplinedef_t) == 14);
 
 #define	ML_BLOCKING			1
@@ -119,7 +119,7 @@
 	short		angle;
 	short		type;
 	short		options;
-} mapthing_t;
+} __attribute__((packed)) mapthing_t;
 COMPILE_TIME_ASSERT(mapthing_t, sizeof(mapthing_t) == 10);
 
 #define	MTF_EASY		1
diff -ru orig/hheretic-0.2.0-src/include/doomdef.h a1200/hheretic-0.2.0-src/include/doomdef.h
--- orig/hheretic-0.2.0-src/include/doomdef.h	2009-06-07 16:32:15.000000000 -0400
+++ a1200/hheretic-0.2.0-src/include/doomdef.h	2009-08-20 10:00:02.000000000 -0400
@@ -1383,5 +1383,11 @@
 
 #include "sounds.h"
 
-#endif	/* __DOOMDEF__ */
+#include <SDL.h>
+SDL_AudioSpec obtained;
+boolean _audioSuspended;
+	int mySDL_PollEvent(SDL_Event *event);
+	void suspendAudio();
+	int resumeAudio();
 
+#endif	/* __DOOMDEF__ */
diff -ru orig/hheretic-0.2.0-src/sdl/i_sdl.c a1200/hheretic-0.2.0-src/sdl/i_sdl.c
--- orig/hheretic-0.2.0-src/sdl/i_sdl.c	2009-05-25 16:55:15.000000000 -0400
+++ a1200/hheretic-0.2.0-src/sdl/i_sdl.c	2009-08-20 06:52:38.000000000 -0400
@@ -496,10 +496,50 @@
 void I_StartTic (void)
 {
 	SDL_Event Event;
-	while ( SDL_PollEvent(&Event) )
+	while ( mySDL_PollEvent(&Event) )
 		I_GetEvent(&Event);
 }
 
+int mySDL_PollEvent(SDL_Event *event)  {
+	int _r= SDL_PollEvent(event);
+	if (!_r)
+		return 0;
+	if (event->type == SDL_ACTIVEEVENT) {
+		if (event->active.state == SDL_APPINPUTFOCUS && !event->active.gain) {
+			suspendAudio(); 
+			for (;;) {
+				_r = SDL_WaitEvent(event);
+				if (!_r)
+					continue;
+				if (event->type == SDL_QUIT)
+					return 1;
+				if (event->type != SDL_ACTIVEEVENT)
+					continue;
+				if (event->active.state == SDL_APPINPUTFOCUS && event->active.gain) {
+					resumeAudio();
+						return 1;
+				}
+			}
+		}
+	}
+  return _r; 
+}
+
+void suspendAudio() {
+	SDL_CloseAudio();
+	_audioSuspended = true;
+}
+
+int resumeAudio() {
+//	if (!_audioSuspended)
+//		return -2;
+	if (SDL_OpenAudio(&obtained, NULL) < 0){
+		return -1;
+	}
+	SDL_PauseAudio(0);
+	_audioSuspended = false;
+	return 0;
+} 
 
 /*
 ============================================================================
@@ -522,4 +562,3 @@
 {
 	mousepresent = 1;
 }
-
diff -ru orig/hheretic-0.2.0-src/sdl/i_sndsdl.c a1200/hheretic-0.2.0-src/sdl/i_sndsdl.c
--- orig/hheretic-0.2.0-src/sdl/i_sndsdl.c	2009-06-04 11:00:34.000000000 -0400
+++ a1200/hheretic-0.2.0-src/sdl/i_sndsdl.c	2009-08-20 06:40:34.000000000 -0400
@@ -330,7 +330,8 @@
 // inits all sound stuff
 void I_StartupSound (void)
 {
-	SDL_AudioSpec desired, obtained;
+//	SDL_AudioSpec desired, obtained;
+	SDL_AudioSpec desired;
 
 	if (snd_initialized)
 		return;
@@ -460,4 +461,3 @@
 void I_PlaySong(int handle, boolean looping)
 {
 }
-

